
/* Functions declaration */
#if M_I86SM==1
    void BackgroundOn(int (*FAddress)());
#endif
#if M_I86MM==1
    void BackgroundOn(int (far *FAddress)());
#endif
char *AddExtension(char *Buffer,char *Extension);
void BackgroundOff(void);
void Beep(void);
void BigCursor(void);
char *Bin2Ascii(long Number,char *Buffer);
void Box(char Color,char Type,char L1,char C1,char L2,char C2);
int Buf2Disk(char* AsciiZ,char* Buffer,unsigned int NumBytes);
void ChangeDumpColor(char OldColor,char NewColor,char *p);
char *ChangeExtension(char *Buffer,char *Extension);
int CheckBarMenu(char Number,struct BarMenu *p);
unsigned int CheckChar(unsigned int Character,char ControlCode);
int CheckItemList(int Number,char ItemLength,struct ItemList *p);
int CheckMouse(void);
int CheckMouseButton(char Number,struct MouseButton *p);
void ClearKeyBuf(void);
int CloseFile(int FHandle);
void Cls(char Color,char L1,char C1,char L2,char C2);
int CreateFile(char *Fname,int *FHandle,int FAttrib);
void CursorOff(void);
void CursorOn(void);
int DeleteFile(char *Fname);
int DialogBox(char BoxColor,char *Prompt,char InputColor,char MaxChar,char CharType,char *Buffer);
void DisableMouse(void);
void DrawBarMenu(char NormalColor,char SelectedColor,char NumItems,char Selection,struct BarMenu* p);
void DrawItemList(char NormalColor,char SelectedColor,int Number,int Selection,struct ItemList *p);
void DrawMouseButton(char NormalColor,char SelectedColor,char Number,char Selection,struct MouseButton *p);
void ErrorBox(int ErrNum);
int Fields(char C1,char C2,char NFields,struct InputFields *p,unsigned int ExitKey,unsigned int HelpKey);
int FileBox(char NColor,char RColor,char *Buffer);
int File2Buf(char* AsciiZ,char* Buffer,int* Bytes);
char GetCurLine(void);
char GetCurCol(void);
int GetCurrentDir(char *PathBuffer);
int GetCurSize(void);
struct DateData *GetDate(void);
int GetDefaultDrive(void);
long GetDiskFreeSpace(char Drive);
unsigned int GetExtendedAscii(unsigned int Character);
int GetFileMode(char *Filename,unsigned int *FMode);
long GetFilePt(int Handle);
long GetFileSize(int FHandle);
long GetFreeMem(void);
unsigned int GetKey(void);
int GetString(char PromptColor,char PromptLine,char PromptCol,char* Prompt, char Color,char Line,char Col,char MaxChar,char CharType,char *Buffer);
void GSSBox(char Color,char Type,char L1,char C1,char L2,char C2,int GrowFl,int SoundFl,int ShadowFl);
char *GetTime(void);
void HideMouse(void);
void InitUserError(struct ErrorMess* p);
void InitVideo(void);
int KeyReady(void);
unsigned char KeyStatus(void);
int ListManager(char NColor,char RColor,int Number,char Length,int Selection,char Lines,char Cols,struct ItemList*p);
int MakeDir(char *String);
int Menu(char NColor, char RColor, char HColor,char NumOpt,struct MenuOpt *k);
int MenuSys(char NColor,char RColor,char HColor,char MenuNumber,struct BarMenu *p,struct MenuSysData *s);
void MessageOn(char Color,char *p);
void MessageOff(void);
int MouseMenu(char NColor,char RColor,char HColor,char NumOpt,struct MenuOpt *k,int XMin,int XMax,int YMin,int YMax);
int MoveFilePt2Offset(int Handle,unsigned long NBytes);
int MoveFilePt(int Handle,unsigned long NBytes);
int OpenFile(char *Fname, int *FHandle, char OMode);
int PopMenu(char NColor,char RColor,char HColor,struct PopMenuData *k);
int ReadFile(int FHandle,char *FBuffer,int FBytes);
int RemoveDir(char *String);
int RenameFile(char *OldName,char *NewName);
int ResetMouse(void);
void ScreenDump(char Row,char Column,char *StringAdr);
int ScrollList(char NColor,char RColor,char L1,char C1,char Lines,int *p);
void ScrollUp(char Color,char Row1,char Col1,char Row2,char Col2,char Scroll);
void SetCurPos(char Row,char Col);
void SetCurSize(int CursorSize);
int SetFileMode(char *Filename, int NewMode);
void SetHorLimit(int Minimum,int Maximum);
void SetMouseIsr(void);
void SetMousePos(int X,int Y);
void SetVerLimit(int Minimum,int Maximum);
void Shadow(char Color,char L1,char C1,char L2,char C2);
void ShowMouse(void);
void SortPointers(int *PArray);
void Sound(int Freq);
void SoundOff(void);
void SoundOn(void);
long StopWatch(int Function);
int TagList(char NColor,char RColor,struct TagList *p);
int TagMenu(char NColor,char RColor,char HColor,char NumOpt,struct MenuOpt *k,int XMin,int XMax,int YMin,int YMax);
void TrapInt23(void);
void TrapInt24(void);
void TSound(int Frequency,unsigned int Duration);
unsigned int Video(void);
void Window(char Color,char Row1,char Col1,char Row2,char Colo2,char* Flag,char* Buffer);
void WriteScreen(char Atributte,char Row,char Column,char* StringAdr);
int WaitKeyMouse(void);
void WaitTime(unsigned int HSec);
void WriteChar(char Color,char Line,char Col,int Count,char Character);
int WriteFile(int FHandle,char *FBuffer,int FBytes);
int YesNo(char NormalColor,char Reverse,char Selection,char *p);

/* Variables */

extern unsigned int VideoSeg;
extern int CrtErrFl;
extern int CURSOR_SIZE;
extern char CharTable;
extern int LEFT_PRESS,LEFT_REL,RIGHT_PRESS,RIGHT_REL,MOUSE_MOVE,MOVEX,MOVEY,LPX,LPY,LRX,LRY,RPX,RPY,RRX,RRY,MOUSE_FLAG;

/* Key Scan-Ascii code */

#define ESC 0x011b
#define ENTER 0x1c0d
#define SPACE 0x3920
#define INS 0x5200
#define DEL 0x5300
#define BACK 0x0E08
#define TAB 0x0F09
#define SHIFTTAB 0x0f00

#define F1 0x3b00
#define F2 0x3c00
#define F3 0x3d00
#define F4 0x3e00
#define F5 0x3f00
#define F6 0x4000
#define F7 0x4100
#define F8 0x4200
#define F9 0x4300
#define F10 0x4400

#define ALTF1 0x6800
#define ALTF2 0x6900
#define ALTF3 0x6A00
#define ALTF4 0x6B00
#define ALTF5 0x6C00
#define ALTF6 0x6D00
#define ALTF7 0x6E00
#define ALTF8 0x6F00
#define ALTF9 0x7000
#define ALTF10 0x7100

#define CTRLF1 0x5E00
#define CTRLF2 0x5F00
#define CTRLF3 0x6000
#define CTRLF4 0x6100
#define CTRLF5 0x6200
#define CTRLF6 0x6300
#define CTRLF7 0x6400
#define CTRLF8 0x6500
#define CTRLF9 0x6600
#define CTRLF10 0x6700

#define SHIFTF1 0x5400
#define SHIFTF2 0x5500
#define SHIFTF3 0x5600
#define SHIFTF4 0x5700
#define SHIFTF5 0x5800
#define SHIFTF6 0x5900
#define SHIFTF7 0x5A00
#define SHIFTF8 0x5B00
#define SHIFTF9 0x5C00
#define SHIFTF10 0x5D00

#define UP 0x4800
#define DOWN 0x5000
#define RIGHT 0x4d00
#define LEFT 0x4b00
#define HOME 0x4700
#define END 0x4F00
#define PgUp 0x4900
#define PgDn 0x5100
#define CTRLRIGHT 0x7400
#define CTRLLEFT 0x7300

#define ALTU 0x1600
#define ALTD 0x2000
#define ALTR 0x1300
#define ALTL 0x2600

/* GetString arguments */

#define ANY         9
#define any         1
#define LETTER      10
#define letter      2
#define digit       4
#define number      0x14
#define filespec    0x26
#define FILESPEC    0x2e
#define espanol     0x42
#define CAPITALIZE  8
#define punctuation 0x80

extern char GS_INSERT;
extern char GS_EDIT;

/* Key Status masks */

#define INSERT  128
#define CAPSL   64
#define NUML    32
#define SCROLL  16
#define ALT     8
#define CTRL    4
#define LSHIFT  2
#define RSHIFT  1

/* Video */

#define COLOR   0xb800
#define MONO    0xb000
extern char RETRACE_FLAG;


/* Cls */

#define CLS_ALL 0,0,24,79

/* StopWatch */

#define SW_START 0
#define SW_STOP  1

/* TSound */

#define TS_C1   33
#define TS_Cs1  35
#define TS_Df1  35
#define TS_D1   37
#define TS_Ds1  39
#define TS_Ef1  39
#define TS_E1   41
#define TS_F1   44
#define TS_Fs1  46
#define TS_Gf1  46
#define TS_G1   49
#define TS_Gs1  52
#define TS_Af1  52
#define TS_A1   55
#define TS_As1  58
#define TS_Bf1  58
#define TS_B1   62

#define TS_C2   65
#define TS_Cs2  69
#define TS_Df2  69
#define TS_D2   73
#define TS_Ds2  78
#define TS_Ef2  78
#define TS_E2   82
#define TS_F2   87
#define TS_Fs2  93
#define TS_Gf2  93
#define TS_G2   98
#define TS_Gs2  103
#define TS_Af2  103
#define TS_A2   110
#define TS_As2  116
#define TS_Bf2  116
#define TS_B2   123

#define TS_C3   131
#define TS_Cs3  139
#define TS_Df3  139
#define TS_D3   147
#define TS_Ds3  156
#define TS_Ef3  156
#define TS_E3   165
#define TS_F3   175
#define TS_Fs3  185
#define TS_Gf3  185
#define TS_G3   196
#define TS_Gs3  208
#define TS_Af3  208
#define TS_A3   220
#define TS_As3  233
#define TS_Bf3  233
#define TS_B3   247

#define TS_C4   262
#define TS_Cs4  277
#define TS_Df4  277
#define TS_D4   294
#define TS_Ds4  311
#define TS_Ef4  311
#define TS_E4   330
#define TS_F4   349
#define TS_Fs4  370
#define TS_Gf4  370
#define TS_G4   392
#define TS_Gs4  415
#define TS_Af4  415
#define TS_A4   440
#define TS_As4  466
#define TS_Bf4  466
#define TS_B4   494

#define TS_C5   523
#define TS_Cs5  554
#define TS_Df5  554
#define TS_D5   587
#define TS_Ds5  622
#define TS_Ef5  622
#define TS_E5   659
#define TS_F5   698
#define TS_Fs5  740
#define TS_Gf5  740
#define TS_G5   784
#define TS_Gs5  831
#define TS_Af5  831
#define TS_A5   880
#define TS_As5  932
#define TS_Bf5  932
#define TS_B5   988

#define TS_C6   1047
#define TS_Cs6  1109
#define TS_Df6  1109
#define TS_D6   1175
#define TS_Ds6  1245
#define TS_Ef6  1245
#define TS_E6   1329
#define TS_F6   1397
#define TS_Fs6  1480
#define TS_Gf6  1480
#define TS_G6   1568
#define TS_Gs6  1661
#define TS_Af6  1661
#define TS_A6   1760
#define TS_As6  1865
#define TS_Bf6  1865
#define TS_B6   1976

#define TS_C7   2093
#define TS_Cs7  2217
#define TS_Df7  2217
#define TS_D7   2349
#define TS_Ds7  2489
#define TS_Ef7  2489
#define TS_E7   2637
#define TS_F7   2794
#define TS_Fs7  2960
#define TS_Gf7  2960
#define TS_G7   3136
#define TS_Gs7  3322
#define TS_Af7  3322
#define TS_A7   3520
#define TS_As7  3729
#define TS_Bf7  3729
#define TS_B7   3951

#define TS_C8   4186

/* File Attributtes */

#define F_READ_ONLY   1
#define F_HIDDEN      2
#define F_SYSTEM      4
#define F_VOLUME      8
#define F_DIRECTORY   16
#define F_ARCHIVE     32

/* DOS 2.0 File Open Mode */

#define DOS2_READ       0           /* Access Rights */
#define DOS2_WRITE      1
#define DOS2_RW         2

/* DOS 3.0 File Open Mode */

#define DOS3_INHERIT    0           /* Inheritance Flag */
#define DOS3_PRIVATE    0x80

#define DOS3_COMP       0           /* Sharing Mode */
#define DOS3_DENY_RW    0x10
#define DOS3_DENY_W     0x20
#define DOS3_DENY_R     0x30
#define DOS3_DENY_NONE  0x40

#define DOS3_READ       0           /* Access Rights */
#define DOS3_WRITE      1
#define DOS3_RW         2



/* Colors */

#define BLUE_BLACK      1
#define GREEN_BLACK     2
#define CYAN_BLACK      3
#define RED_BLACK       4
#define MAGENTA_BLACK   5
#define BROWN_BLACK     6
#define WHITE_BLACK     7

#define BLACK_BLUE      0x10
#define BLUE_BLUE       0x11
#define GREEN_BLUE      0x12
#define CYAN_BLUE       0x13
#define RED_BLUE        0x14
#define MAGENTA_BLUE    0x15
#define BROWN_BLUE      0x16
#define WHITE_BLUE      0x17

#define BLACK_GREEN     0x20
#define BLUE_GREEN      0x21
#define GREEN_GREEN     0x22
#define CYAN_GREEN      0x23
#define RED_GREEN       0x24
#define MAGENTA_GREEN   0x25
#define BROWN_GREEN     0x26
#define WHITE_GREEN     0x27

#define BLACK_CYAN      0x30
#define BLUE_CYAN       0x31
#define GREEN_CYAN      0x32
#define CYAN_CYAN       0x33
#define RED_CYAN        0x34
#define MAGENTA_CYAN    0x35
#define BROWN_CYAN      0x36
#define WHITE_CYAN      0x37

#define BLACK_RED       0x40
#define BLUE_RED        0x41
#define GREEN_RED       0x42
#define CYAN_RED        0x43
#define RED_RED         0x44
#define MAGENTA_RED     0x45
#define BROWN_RED       0x46
#define WHITE_RED       0x47

#define BLACK_MAGENTA   0x50
#define BLUE_MAGENTA    0x51
#define GREEN_MAGENTA   0x52
#define CYAN_MAGENTA    0x53
#define RED_MAGENTA     0x54
#define MAGENTA_MAGENTA 0x55
#define BROWN_MAGENTA   0x56
#define WHITE_MAGENTA   0x57

#define BLACK_BROWN     0x60
#define BLUE_BROWN      0x61
#define GREEN_BROWN     0x62
#define CYAN_BROWN      0x63
#define RED_BROWN       0x64
#define MAGENTA_BROWN   0x65
#define BROWN_BROWN     0x66
#define WHITE_BROWN     0x67

#define BLACK_WHITE     0x70
#define BLUE_WHITE      0x71
#define GREEN_WHITE     0x72
#define CYAN_WHITE      0x73
#define RED_WHITE       0x74
#define MAGENTA_WHITE   0x75
#define BROWN_WHITE     0x76
#define WHITE_WHITE     0x77

#define HIGHLIGHT       8
#define BLINK           0x80

/* GetTime variables */

extern int GT_HOURS;
extern int GT_MINUTES;
extern int GT_SECONDS;
extern int GT_HUNDRETHS;

/* Menu structures */

struct MenuOpt{
        char Row,Col;
        char *String;
        char Letter;
        };

struct BarMenu{
    char StartCol,EndCol;
    char String[20];
    };


struct PopMenuData{
    char L1,C1,L2,C2;
    char NumberOption;
    char *WinBuffer;
    struct MenuOpt *Menust;
    };

struct MenuSysData{
    unsigned int Key;
    struct PopMenuData *PMenu;
    };

/* Mouse Button */

struct MouseButton{
    char Top,Left,Bottom,Right;
    char Row,Col;
    char String[20];
    };

/* ItemList structure */

struct ItemList{
    char Row,Col;
    char *String;
    };

/* Input Fields structure */

#if M_I86SM==1
struct InputFields{
    char PromptLine;
    char PromptCol;
    char *Prompt;

    char FieldLine;
    char FieldCol;
    char *FieldBuffer;

    char MaxChar;
    char CharType;
    int (* Helpf)(struct InputFields *);
    int (* Checkf)(struct InputFields *);
    };
#endif

#if M_I86MM==1
struct InputFields{
    char PromptLine;
    char PromptCol;
    char *Prompt;

    char FieldLine;
    char FieldCol;
    char *FieldBuffer;

    char MaxChar;
    char CharType;
    int (far * Helpf)(struct InputFields *);
    int (far * Checkf)(struct InputFields *);
    };
#endif

/* Error Box */

struct ErrorMess{
    int ErrorNum;
    char *Message;
    };


/* Tag List structure */

struct TagList{
    char TagFl;
    char *String;
    };

/* Date structure */

struct DateData{
    char WeekDay;
    char MonthDay;
    char Month;
    int Year;
    };
